Option Strict Off
Option Explicit On
Friend Class IO1388
	Inherits System.Windows.Forms.Form
	Dim nCard As Byte
	Dim nOutputs As Integer
	Dim nCardCount As Byte
	Dim bCardtype32 As Boolean
	
	Private Function TestBit(ByRef Value As Integer, ByRef Bit As Byte) As Byte
		Dim x As Integer
		
		If (Bit = 31) Then
			x = &H80000000
		Else
			x = 2 ^ Bit
		End If
		If ((Value And x) <> 0) Then
			TestBit = 1
		Else
			TestBit = 0
		End If
	End Function
	
	Private Sub ShowError()
		Dim x As Short
		Dim y As MsgBoxResult
		
		' *** Get the last error ***
		x = IO1388_GetLastError
		' *** Open messagebox with error-message ***
		Select Case x
			Case IO1388_ERR_OK
				y = MsgBox("There was no error.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_ALREADYOPEN
				y = MsgBox("DLL is already open.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_NOTOPEN
				y = MsgBox("DLL is not open.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_NOCARD
				y = MsgBox("No IO 1388 found.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_NOADDRESS
				y = MsgBox("No address.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_NOVALUE
				y = MsgBox("No value.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_WRONGMODE
				y = MsgBox("Wrong mode.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_VXDNOTFOUND
				y = MsgBox("Driver not found.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_INTERNALERROR
				y = MsgBox("Internal error.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_FUNCDISABLED
				y = MsgBox("Function disabled.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_WRONGVALUE
				y = MsgBox("Wrong value.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_DEVICERUNNING
				y = MsgBox("Device is running.", MsgBoxStyle.Exclamation, "Error")
			Case IO1388_ERR_DEVICESTOPPED
				y = MsgBox("Device is stopped.", MsgBoxStyle.Exclamation, "Error")
            Case Else
                y = MsgBox("Unknown error.", MsgBoxStyle.Exclamation, "Error")
        End Select
	End Sub
	
	Private Sub UpdateCardData()
		Dim x As Integer
		Dim s As String
		
		' * Get serial-number of the card *
		If (IO1388_GetCardNumber(nCard, x) = 0) Then
			ShowError()
		End If
		s = Str(x)
		EditNumber.Text = s
		' * Reread outputs
		If (IO1388_ReadOutputs(nCard, nOutputs) = 0) Then
			' * if an error happens, show message *
			ShowError()
		End If
		' * Update lower 16 outputs *
		CheckOut0.CheckState = TestBit(nOutputs, 0)
		CheckOut1.CheckState = TestBit(nOutputs, 1)
		CheckOut2.CheckState = TestBit(nOutputs, 2)
		CheckOut3.CheckState = TestBit(nOutputs, 3)
		CheckOut4.CheckState = TestBit(nOutputs, 4)
		CheckOut5.CheckState = TestBit(nOutputs, 5)
		CheckOut6.CheckState = TestBit(nOutputs, 6)
		CheckOut7.CheckState = TestBit(nOutputs, 7)
		CheckOut8.CheckState = TestBit(nOutputs, 8)
		CheckOut9.CheckState = TestBit(nOutputs, 9)
		CheckOut10.CheckState = TestBit(nOutputs, 10)
		CheckOut11.CheckState = TestBit(nOutputs, 11)
		CheckOut12.CheckState = TestBit(nOutputs, 12)
		CheckOut13.CheckState = TestBit(nOutputs, 13)
		CheckOut14.CheckState = TestBit(nOutputs, 14)
		CheckOut15.CheckState = TestBit(nOutputs, 15)
		' * Get configuration of the card *
		If (IO1388_ReadTimerStatus(nCard, x) = 0) Then
			' * if an error happens, show message *
			ShowError()
		End If
		If ((x And &H1000000) <> 0) Then
			' * 32/32 card *
			bCardtype32 = True
			' * Enable outputs 16-31 *
			CheckOut16.Enabled = True
			CheckOut17.Enabled = True
			CheckOut18.Enabled = True
			CheckOut19.Enabled = True
			CheckOut20.Enabled = True
			CheckOut21.Enabled = True
			CheckOut22.Enabled = True
			CheckOut23.Enabled = True
			CheckOut24.Enabled = True
			CheckOut25.Enabled = True
			CheckOut26.Enabled = True
			CheckOut27.Enabled = True
			CheckOut28.Enabled = True
			CheckOut29.Enabled = True
			CheckOut30.Enabled = True
			CheckOut31.Enabled = True
			' * Show unchecked *
			CheckOut16.CheckState = TestBit(nOutputs, 16)
			CheckOut17.CheckState = TestBit(nOutputs, 17)
			CheckOut18.CheckState = TestBit(nOutputs, 18)
			CheckOut19.CheckState = TestBit(nOutputs, 19)
			CheckOut20.CheckState = TestBit(nOutputs, 20)
			CheckOut21.CheckState = TestBit(nOutputs, 21)
			CheckOut22.CheckState = TestBit(nOutputs, 22)
			CheckOut23.CheckState = TestBit(nOutputs, 23)
			CheckOut24.CheckState = TestBit(nOutputs, 24)
			CheckOut25.CheckState = TestBit(nOutputs, 25)
			CheckOut26.CheckState = TestBit(nOutputs, 26)
			CheckOut27.CheckState = TestBit(nOutputs, 27)
			CheckOut28.CheckState = TestBit(nOutputs, 28)
			CheckOut29.CheckState = TestBit(nOutputs, 29)
			CheckOut30.CheckState = TestBit(nOutputs, 30)
			CheckOut31.CheckState = TestBit(nOutputs, 31)
		Else
			' * 16/16 card *
			bCardtype32 = False
			' * Disable outputs 16-31 *
			CheckOut16.Enabled = False
			CheckOut17.Enabled = False
			CheckOut18.Enabled = False
			CheckOut19.Enabled = False
			CheckOut20.Enabled = False
			CheckOut21.Enabled = False
			CheckOut22.Enabled = False
			CheckOut23.Enabled = False
			CheckOut24.Enabled = False
			CheckOut25.Enabled = False
			CheckOut26.Enabled = False
			CheckOut27.Enabled = False
			CheckOut28.Enabled = False
			CheckOut29.Enabled = False
			CheckOut30.Enabled = False
			CheckOut31.Enabled = False
			' * Show upper 16 outputs unchecked *
			CheckOut16.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut17.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut18.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut19.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut20.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut21.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut22.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut23.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut24.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut25.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut26.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut27.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut28.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut29.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut30.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckOut31.CheckState = System.Windows.Forms.CheckState.Unchecked
			' * Show upper 16 inputs unchecked *
			CheckIn16.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn17.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn18.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn19.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn20.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn21.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn22.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn23.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn24.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn25.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn26.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn27.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn28.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn29.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn30.CheckState = System.Windows.Forms.CheckState.Unchecked
			CheckIn31.CheckState = System.Windows.Forms.CheckState.Unchecked
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut0.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut0_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut0.CheckStateChanged
		' * Get checkstate *
		If (CheckOut0.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H1s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H1s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut1.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut1_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut1.CheckStateChanged
		' * Get checkstate *
		If (CheckOut1.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H2s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H2s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut10.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut10_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut10.CheckStateChanged
		' * Get checkstate *
		If (CheckOut10.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H400s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H400s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut11.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut11_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut11.CheckStateChanged
		' * Get checkstate *
		If (CheckOut11.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H800s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H800s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut12.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut12_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut12.CheckStateChanged
		' * Get checkstate *
		If (CheckOut12.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H1000s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H1000s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut13.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut13_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut13.CheckStateChanged
		' * Get checkstate *
		If (CheckOut13.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H2000s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H2000s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut14.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut14_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut14.CheckStateChanged
		' * Get checkstate *
		If (CheckOut14.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H4000s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H4000s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut15.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut15_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut15.CheckStateChanged
		' * Get checkstate *
		If (CheckOut15.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H8000s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H8000s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut16.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut16_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut16.CheckStateChanged
		' * Get checkstate *
		If (CheckOut16.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H10000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H10000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut17.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut17_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut17.CheckStateChanged
		' * Get checkstate *
		If (CheckOut17.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H20000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H20000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut18.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut18_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut18.CheckStateChanged
		' * Get checkstate *
		If (CheckOut18.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H40000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H40000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut19.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut19_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut19.CheckStateChanged
		' * Get checkstate *
		If (CheckOut19.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H80000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H80000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut2.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut2_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut2.CheckStateChanged
		' * Get checkstate *
		If (CheckOut2.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H4s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H4s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut20.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut20_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut20.CheckStateChanged
		' * Get checkstate *
		If (CheckOut20.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H100000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H100000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut21.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut21_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut21.CheckStateChanged
		' * Get checkstate *
		If (CheckOut21.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H200000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H200000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut22.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut22_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut22.CheckStateChanged
		' * Get checkstate *
		If (CheckOut22.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H400000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H400000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut23.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut23_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut23.CheckStateChanged
		' * Get checkstate *
		If (CheckOut23.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H800000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H800000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut24.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut24_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut24.CheckStateChanged
		' * Get checkstate *
		If (CheckOut24.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H1000000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H1000000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut25.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut25_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut25.CheckStateChanged
		' * Get checkstate *
		If (CheckOut25.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H2000000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H2000000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut26.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut26_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut26.CheckStateChanged
		' * Get checkstate *
		If (CheckOut26.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H4000000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H4000000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut27.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut27_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut27.CheckStateChanged
		' * Get checkstate *
		If (CheckOut27.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H8000000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H8000000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut28.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut28_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut28.CheckStateChanged
		' * Get checkstate *
		If (CheckOut28.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H10000000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H10000000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut29.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut29_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut29.CheckStateChanged
		' * Get checkstate *
		If (CheckOut29.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H20000000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H20000000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut3.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut3_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut3.CheckStateChanged
		' * Get checkstate *
		If (CheckOut3.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H8s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H8s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut30.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut30_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut30.CheckStateChanged
		' * Get checkstate *
		If (CheckOut30.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H40000000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H40000000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut31.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut31_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut31.CheckStateChanged
		' * Get checkstate *
		If (CheckOut31.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H80000000
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H80000000)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut4.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut4_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut4.CheckStateChanged
		' * Get checkstate *
		If (CheckOut4.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H10s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H10s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut5.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut5_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut5.CheckStateChanged
		' * Get checkstate *
		If (CheckOut5.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H20s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H20s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut6.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut6_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut6.CheckStateChanged
		' * Get checkstate *
		If (CheckOut6.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H40s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H40s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut7.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut7_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut7.CheckStateChanged
		' * Get checkstate *
		If (CheckOut7.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H80s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H80s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut8.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut8_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut8.CheckStateChanged
		' * Get checkstate *
		If (CheckOut8.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H100s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H100s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	'UPGRADE_WARNING: Das Ereignis CheckOut9.CheckStateChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub CheckOut9_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CheckOut9.CheckStateChanged
		' * Get checkstate *
		If (CheckOut9.CheckState = 1) Then
			' * if checked, set output to 1 (on) *
			nOutputs = nOutputs Or &H200s
		Else
			' * if not checked, set output to 0 (off) *
			nOutputs = nOutputs And (&HFFFFFFFF Xor &H200s)
		End If
		' * Set Outputs to new value *
		If (IO1388_WriteOutputs(nCard, nOutputs) = 0) Then
			ShowError()
		End If
	End Sub
	
	Private Sub CommandCancel_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CommandCancel.Click
        ' * Stop Timer *
        Timer1.Enabled = False
        ' * Stop irq handling *
        ' If (IO1388_StopIRQ(nCard) = 0) Then
        ' ShowError()
        'End If
        ' * Workaround StopIRQ may return wrong OK-Values *
        IO1388_StopIRQ(nCard)
        ' * Disable all interrupts *
        If (IO1388_WriteIntRise(nCard, 0) = 0) Then
            ShowError()
        End If
        If (IO1388_WriteIntFall(nCard, 0) = 0) Then
            ShowError()
        End If
        ' * Reset interrupt-enable *
        If (IO1388_WriteTimerStatus(nCard, &H0) = 0) Then
            ShowError()
        End If
        ' * Set outputs to known state *
        If (nCardCount > 0) Then
            If (IO1388_WriteOutputs(0, 0) = 0) Then
                ShowError()
            End If
        End If
        If (nCardCount > 1) Then
            If (IO1388_WriteOutputs(1, 0) = 0) Then
                ShowError()
            End If
        End If
        If (nCardCount > 2) Then
            If (IO1388_WriteOutputs(2, 0) = 0) Then
                ShowError()
            End If
        End If
        If (nCardCount > 3) Then
            If (IO1388_WriteOutputs(3, 0) = 0) Then
                ShowError()
            End If
        End If
        ' *** Close IO1388.DLL ***
        IO1388_DeInitDriver()
        End
    End Sub


	Private Sub IO1388_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Dim x As Byte
        Dim y As Long

		' * Start with card 0 *
		nCard = 0
		OptionCard0.Checked = True
		OptionCard1.Checked = False
		OptionCard2.Checked = False
		OptionCard3.Checked = False
		' *** Open IO1388.DLL ***
		If (IO1388_InitDriver() = 0) Then
			' * if an error happens, show message *
			ShowError()
			FileClose()
		Else
			' * Look for installed cards *
			If (IO1388_GetCardCount(x) = 0) Then
				ShowError()
			End If
			' * 1 Card found? *
			If (x = 0) Then
				End
			End If
			Select Case x
				Case 1
					OptionCard1.Enabled = False
					OptionCard2.Enabled = False
					OptionCard3.Enabled = False
				Case 2
					OptionCard1.Enabled = True
					OptionCard2.Enabled = False
					OptionCard3.Enabled = False
				Case 3
					OptionCard1.Enabled = True
					OptionCard2.Enabled = True
					OptionCard3.Enabled = False
				Case 4
					OptionCard1.Enabled = True
					OptionCard2.Enabled = True
					OptionCard3.Enabled = True
				Case Else
					OptionCard0.Enabled = False
					OptionCard1.Enabled = False
					OptionCard2.Enabled = False
					OptionCard3.Enabled = False
			End Select
			nCardCount = x
			' * Set outputs to known state *
			If (nCardCount > 0) Then
				If (IO1388_WriteOutputs(0, 0) = 0) Then
					ShowError()
				End If
			End If
			If (nCardCount > 1) Then
				If (IO1388_WriteOutputs(1, 0) = 0) Then
					ShowError()
				End If
			End If
			If (nCardCount > 2) Then
				If (IO1388_WriteOutputs(2, 0) = 0) Then
					ShowError()
				End If
			End If
			If (nCardCount > 3) Then
				If (IO1388_WriteOutputs(3, 0) = 0) Then
					ShowError()
				End If
			End If
			' * Enable/disable used/unused checkboxes *
			UpdateCardData()
            nOutputs = 0
            ' * Get actual state of inputs *
            If (IO1388_ReadInputs(nCard, y) = 0) Then
                ShowError()
            Else
                ' * Show the inputs *
                CheckIn0.CheckState = TestBit(y, 0)
                CheckIn1.CheckState = TestBit(y, 1)
                CheckIn2.CheckState = TestBit(y, 2)
                CheckIn3.CheckState = TestBit(y, 3)
                CheckIn4.CheckState = TestBit(y, 4)
                CheckIn5.CheckState = TestBit(y, 5)
                CheckIn6.CheckState = TestBit(y, 6)
                CheckIn7.CheckState = TestBit(y, 7)
                CheckIn8.CheckState = TestBit(y, 8)
                CheckIn9.CheckState = TestBit(y, 9)
                CheckIn10.CheckState = TestBit(y, 10)
                CheckIn11.CheckState = TestBit(y, 11)
                CheckIn12.CheckState = TestBit(y, 12)
                CheckIn13.CheckState = TestBit(y, 13)
                CheckIn14.CheckState = TestBit(y, 14)
                CheckIn15.CheckState = TestBit(y, 15)
                If (bCardtype32) Then
                    CheckIn16.CheckState = TestBit(y, 16)
                    CheckIn17.CheckState = TestBit(y, 17)
                    CheckIn18.CheckState = TestBit(y, 18)
                    CheckIn19.CheckState = TestBit(y, 19)
                    CheckIn20.CheckState = TestBit(y, 20)
                    CheckIn21.CheckState = TestBit(y, 21)
                    CheckIn22.CheckState = TestBit(y, 22)
                    CheckIn23.CheckState = TestBit(y, 23)
                    CheckIn24.CheckState = TestBit(y, 24)
                    CheckIn25.CheckState = TestBit(y, 25)
                    CheckIn26.CheckState = TestBit(y, 26)
                    CheckIn27.CheckState = TestBit(y, 27)
                    CheckIn28.CheckState = TestBit(y, 28)
                    CheckIn29.CheckState = TestBit(y, 29)
                    CheckIn30.CheckState = TestBit(y, 30)
                    CheckIn31.CheckState = TestBit(y, 31)
                End If
            End If
            ' * Enable all IO interrupts *
            If (IO1388_WriteIntRise(nCard, &HFFFFFFFF) = 0) Then
                ShowError()
            End If
            If (IO1388_WriteIntFall(nCard, &HFFFFFFFF) = 0) Then
                ShowError()
            End If
            ' * Set global and IO-interrupt-enable *
            If (IO1388_WriteTimerStatus(nCard, IO1388_GLOBAL_IRQ_ENABLE + IO1388_IO_IRQ_ENABLE) = 0) Then
                ShowError()
            End If
            ' * Start irq handling *
            'If (IO1388_StartIRQ(nCard) = 0) Then
            'ShowError()
            'End If
            ' * Workaround StartIRQ may return wrong OK-Values *
            IO1388_StartIRQ(nCard)

            UpdateView()
        End If
    End Sub
	
	Private Sub UpdateView()
        Dim x As Integer
        Dim IRQBuffer(255) As Long
        Dim n As Integer
		
        ' * Get irq state of the inputs *
        If (IO1388_GetIRQStatus(nCard, x) = 0) Then
            ShowError()
        Else
            ' *New values stored? *
            If ((x And IO1388_VALUE) <> 0) Then
                ' *New values available, get a block of values *
                n = 256
                If (IO1388_GetIRQInputs(nCard, IRQBuffer(0), 256, n) = 0) Then
                    ShowError()
                Else
                    If (n > 0) Then
                        ' * Newest value is the last in this block *
                        x = IRQBuffer(n - 1)
                        ' * Show the inputs *
                        CheckIn0.CheckState = TestBit(x, 0)
                        CheckIn1.CheckState = TestBit(x, 1)
                        CheckIn2.CheckState = TestBit(x, 2)
                        CheckIn3.CheckState = TestBit(x, 3)
                        CheckIn4.CheckState = TestBit(x, 4)
                        CheckIn5.CheckState = TestBit(x, 5)
                        CheckIn6.CheckState = TestBit(x, 6)
                        CheckIn7.CheckState = TestBit(x, 7)
                        CheckIn8.CheckState = TestBit(x, 8)
                        CheckIn9.CheckState = TestBit(x, 9)
                        CheckIn10.CheckState = TestBit(x, 10)
                        CheckIn11.CheckState = TestBit(x, 11)
                        CheckIn12.CheckState = TestBit(x, 12)
                        CheckIn13.CheckState = TestBit(x, 13)
                        CheckIn14.CheckState = TestBit(x, 14)
                        CheckIn15.CheckState = TestBit(x, 15)
                        If (bCardtype32) Then
                            CheckIn16.CheckState = TestBit(x, 16)
                            CheckIn17.CheckState = TestBit(x, 17)
                            CheckIn18.CheckState = TestBit(x, 18)
                            CheckIn19.CheckState = TestBit(x, 19)
                            CheckIn20.CheckState = TestBit(x, 20)
                            CheckIn21.CheckState = TestBit(x, 21)
                            CheckIn22.CheckState = TestBit(x, 22)
                            CheckIn23.CheckState = TestBit(x, 23)
                            CheckIn24.CheckState = TestBit(x, 24)
                            CheckIn25.CheckState = TestBit(x, 25)
                            CheckIn26.CheckState = TestBit(x, 26)
                            CheckIn27.CheckState = TestBit(x, 27)
                            CheckIn28.CheckState = TestBit(x, 28)
                            CheckIn29.CheckState = TestBit(x, 29)
                            CheckIn30.CheckState = TestBit(x, 30)
                            CheckIn31.CheckState = TestBit(x, 31)
                        End If
                    End If
                End If
            End If
        End If
    End Sub
	

	'UPGRADE_WARNING: Das Ereignis OptionCard0.CheckedChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub OptionCard0_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles OptionCard0.CheckedChanged
        If eventSender.Checked Then
            Dim x As Integer

            ' * Stop irq handling for old card *
            ' If (IO1388_StopIRQ(nCard) = 0) Then
            ' ShowError()
            ' End If
            ' * Workaround StopIRQ may return wrong OK-Values *
            IO1388_StopIRQ(nCard)
            ' * Disable all interrupts *
            If (IO1388_WriteIntRise(nCard, 0) = 0) Then
                ShowError()
            End If
            If (IO1388_WriteIntFall(nCard, 0) = 0) Then
                ShowError()
            End If
            ' * Reset interrupt-enable *
            If (IO1388_WriteTimerStatus(nCard, &H0) = 0) Then
                ShowError()
            End If
            ' * Set new card *
            nCard = 0
            ' * Get state of outputs *
            If (IO1388_ReadOutputs(nCard, x) = 0) Then
                ShowError()
            End If
            nOutputs = x
            ' * Get actual state of inputs iof the new card *
            If (IO1388_ReadInputs(nCard, x) = 0) Then
                ShowError()
            Else
                ' * Show the inputs *
                CheckIn0.CheckState = TestBit(x, 0)
                CheckIn1.CheckState = TestBit(x, 1)
                CheckIn2.CheckState = TestBit(x, 2)
                CheckIn3.CheckState = TestBit(x, 3)
                CheckIn4.CheckState = TestBit(x, 4)
                CheckIn5.CheckState = TestBit(x, 5)
                CheckIn6.CheckState = TestBit(x, 6)
                CheckIn7.CheckState = TestBit(x, 7)
                CheckIn8.CheckState = TestBit(x, 8)
                CheckIn9.CheckState = TestBit(x, 9)
                CheckIn10.CheckState = TestBit(x, 10)
                CheckIn11.CheckState = TestBit(x, 11)
                CheckIn12.CheckState = TestBit(x, 12)
                CheckIn13.CheckState = TestBit(x, 13)
                CheckIn14.CheckState = TestBit(x, 14)
                CheckIn15.CheckState = TestBit(x, 15)
                If (bCardtype32) Then
                    CheckIn16.CheckState = TestBit(x, 16)
                    CheckIn17.CheckState = TestBit(x, 17)
                    CheckIn18.CheckState = TestBit(x, 18)
                    CheckIn19.CheckState = TestBit(x, 19)
                    CheckIn20.CheckState = TestBit(x, 20)
                    CheckIn21.CheckState = TestBit(x, 21)
                    CheckIn22.CheckState = TestBit(x, 22)
                    CheckIn23.CheckState = TestBit(x, 23)
                    CheckIn24.CheckState = TestBit(x, 24)
                    CheckIn25.CheckState = TestBit(x, 25)
                    CheckIn26.CheckState = TestBit(x, 26)
                    CheckIn27.CheckState = TestBit(x, 27)
                    CheckIn28.CheckState = TestBit(x, 28)
                    CheckIn29.CheckState = TestBit(x, 29)
                    CheckIn30.CheckState = TestBit(x, 30)
                    CheckIn31.CheckState = TestBit(x, 31)
                End If
            End If
            ' * Enable all interrupts *
            If (IO1388_WriteIntRise(nCard, &HFFFFFFFF) = 0) Then
                ShowError()
            End If
            If (IO1388_WriteIntFall(nCard, &HFFFFFFFF) = 0) Then
                ShowError()
            End If
            ' * Set gloabl- and IO-interrupt-enable *
            If (IO1388_WriteTimerStatus(nCard, IO1388_GLOBAL_IRQ_ENABLE + IO1388_IO_IRQ_ENABLE) = 0) Then
                ShowError()
            End If
            ' * Start irq handling for new card *
            'If (IO1388_StartIRQ(nCard) = 0) Then
            '   ShowError()
            'End If
            ' * Workaround StartIRQ may return wrong OK-Values *
            IO1388_StartIRQ(nCard)
            ' * Update visible elements *
            UpdateCardData()
            ' * Update view *
            UpdateView()
        End If
    End Sub
	
	'UPGRADE_WARNING: Das Ereignis OptionCard1.CheckedChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub OptionCard1_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles OptionCard1.CheckedChanged
        If eventSender.Checked Then
            Dim x As Integer

            ' * Stop irq handling for old card *
            ' If (IO1388_StopIRQ(nCard) = 0) Then
            ' ShowError()
            ' End If
            ' * Workaround StopIRQ may return wrong OK-Values *
            IO1388_StopIRQ(nCard)
            ' * Disable all interrupts *
            If (IO1388_WriteIntRise(nCard, 0) = 0) Then
                ShowError()
            End If
            If (IO1388_WriteIntFall(nCard, 0) = 0) Then
                ShowError()
            End If
            ' * Reset interrupt-enable *
            If (IO1388_WriteTimerStatus(nCard, 0) = 0) Then
                ShowError()
            End If
            ' * Set new card *
            nCard = 1
            ' * Get state of outputs *
            If (IO1388_ReadOutputs(nCard, x) = 0) Then
                ShowError()
            End If
            nOutputs = x
            ' * Get actual state of inputs iof the new card *
            If (IO1388_ReadInputs(nCard, x) = 0) Then
                ShowError()
            Else
                ' * Show the inputs *
                CheckIn0.CheckState = TestBit(x, 0)
                CheckIn1.CheckState = TestBit(x, 1)
                CheckIn2.CheckState = TestBit(x, 2)
                CheckIn3.CheckState = TestBit(x, 3)
                CheckIn4.CheckState = TestBit(x, 4)
                CheckIn5.CheckState = TestBit(x, 5)
                CheckIn6.CheckState = TestBit(x, 6)
                CheckIn7.CheckState = TestBit(x, 7)
                CheckIn8.CheckState = TestBit(x, 8)
                CheckIn9.CheckState = TestBit(x, 9)
                CheckIn10.CheckState = TestBit(x, 10)
                CheckIn11.CheckState = TestBit(x, 11)
                CheckIn12.CheckState = TestBit(x, 12)
                CheckIn13.CheckState = TestBit(x, 13)
                CheckIn14.CheckState = TestBit(x, 14)
                CheckIn15.CheckState = TestBit(x, 15)
                If (bCardtype32) Then
                    CheckIn16.CheckState = TestBit(x, 16)
                    CheckIn17.CheckState = TestBit(x, 17)
                    CheckIn18.CheckState = TestBit(x, 18)
                    CheckIn19.CheckState = TestBit(x, 19)
                    CheckIn20.CheckState = TestBit(x, 20)
                    CheckIn21.CheckState = TestBit(x, 21)
                    CheckIn22.CheckState = TestBit(x, 22)
                    CheckIn23.CheckState = TestBit(x, 23)
                    CheckIn24.CheckState = TestBit(x, 24)
                    CheckIn25.CheckState = TestBit(x, 25)
                    CheckIn26.CheckState = TestBit(x, 26)
                    CheckIn27.CheckState = TestBit(x, 27)
                    CheckIn28.CheckState = TestBit(x, 28)
                    CheckIn29.CheckState = TestBit(x, 29)
                    CheckIn30.CheckState = TestBit(x, 30)
                    CheckIn31.CheckState = TestBit(x, 31)
                End If
            End If
            ' * Enable all interrupts *
            If (IO1388_WriteIntRise(nCard, &HFFFFFFFF) = 0) Then
                ShowError()
            End If
            If (IO1388_WriteIntFall(nCard, &HFFFFFFFF) = 0) Then
                ShowError()
            End If
            ' * Set global- and IO-interrupt-enable *
            If (IO1388_WriteTimerStatus(nCard, IO1388_GLOBAL_IRQ_ENABLE + IO1388_IO_IRQ_ENABLE) = 0) Then
                ShowError()
            End If
            ' * Start irq handling for new card *
            ' If (IO1388_StartIRQ(nCard) = 0) Then
            ' ShowError()
            ' End If
            ' * Workaround StartIRQ may return wrong OK-Values *
            IO1388_StartIRQ(nCard)
            ' * Update visible elements *
            UpdateCardData()
            ' * Update view *
            UpdateView()
        End If
    End Sub
	
	'UPGRADE_WARNING: Das Ereignis OptionCard2.CheckedChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub OptionCard2_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles OptionCard2.CheckedChanged
        If eventSender.Checked Then
            Dim x As Integer

            ' * Stop irq handling for old card *
            ' If (IO1388_StopIRQ(nCard) = 0) Then
            ' ShowError()
            ' End If
            ' * Workaround StopIRQ may return wrong OK-Values *
            IO1388_StopIRQ(nCard)
            ' * Disable all interrupts *
            If (IO1388_WriteIntRise(nCard, 0) = 0) Then
                ShowError()
            End If
            If (IO1388_WriteIntFall(nCard, 0) = 0) Then
                ShowError()
            End If
            ' * Reset interrupt-enable *
            If (IO1388_WriteTimerStatus(nCard, 0) = 0) Then
                ShowError()
            End If
            ' * Set new card *
            nCard = 2
            ' * Get state of outputs *
            If (IO1388_ReadOutputs(nCard, x) = 0) Then
                ShowError()
            End If
            nOutputs = x
            ' * Get actual state of inputs iof the new card *
            If (IO1388_ReadInputs(nCard, x) = 0) Then
                ShowError()
            Else
                ' * Show the inputs *
                CheckIn0.CheckState = TestBit(x, 0)
                CheckIn1.CheckState = TestBit(x, 1)
                CheckIn2.CheckState = TestBit(x, 2)
                CheckIn3.CheckState = TestBit(x, 3)
                CheckIn4.CheckState = TestBit(x, 4)
                CheckIn5.CheckState = TestBit(x, 5)
                CheckIn6.CheckState = TestBit(x, 6)
                CheckIn7.CheckState = TestBit(x, 7)
                CheckIn8.CheckState = TestBit(x, 8)
                CheckIn9.CheckState = TestBit(x, 9)
                CheckIn10.CheckState = TestBit(x, 10)
                CheckIn11.CheckState = TestBit(x, 11)
                CheckIn12.CheckState = TestBit(x, 12)
                CheckIn13.CheckState = TestBit(x, 13)
                CheckIn14.CheckState = TestBit(x, 14)
                CheckIn15.CheckState = TestBit(x, 15)
                If (bCardtype32) Then
                    CheckIn16.CheckState = TestBit(x, 16)
                    CheckIn17.CheckState = TestBit(x, 17)
                    CheckIn18.CheckState = TestBit(x, 18)
                    CheckIn19.CheckState = TestBit(x, 19)
                    CheckIn20.CheckState = TestBit(x, 20)
                    CheckIn21.CheckState = TestBit(x, 21)
                    CheckIn22.CheckState = TestBit(x, 22)
                    CheckIn23.CheckState = TestBit(x, 23)
                    CheckIn24.CheckState = TestBit(x, 24)
                    CheckIn25.CheckState = TestBit(x, 25)
                    CheckIn26.CheckState = TestBit(x, 26)
                    CheckIn27.CheckState = TestBit(x, 27)
                    CheckIn28.CheckState = TestBit(x, 28)
                    CheckIn29.CheckState = TestBit(x, 29)
                    CheckIn30.CheckState = TestBit(x, 30)
                    CheckIn31.CheckState = TestBit(x, 31)
                End If
            End If
            ' * Enable all interrupts *
            If (IO1388_WriteIntRise(nCard, &HFFFFFFFF) = 0) Then
                ShowError()
            End If
            If (IO1388_WriteIntFall(nCard, &HFFFFFFFF) = 0) Then
                ShowError()
            End If
            ' * Set global- and IO-interrupt-enable *
            If (IO1388_WriteTimerStatus(nCard, IO1388_GLOBAL_IRQ_ENABLE + IO1388_IO_IRQ_ENABLE) = 0) Then
                ShowError()
            End If
            ' * Start irq handling for new card *
            ' If (IO1388_StartIRQ(nCard) = 0) Then
            ' ShowError()
            ' End If
            ' * Workaround StartIRQ may return wrong OK-Values *
            IO1388_StartIRQ(nCard)
            ' * Update visible elements *
            UpdateCardData()
            ' * Update view *
            UpdateView()
        End If
    End Sub
	
	'UPGRADE_WARNING: Das Ereignis OptionCard3.CheckedChanged kann ausgelst werden, wenn das Formular initialisiert wird. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub OptionCard3_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles OptionCard3.CheckedChanged
		If eventSender.Checked Then
			Dim x As Integer

            ' * Stop irq handling for old card *
            ' If (IO1388_StopIRQ(nCard) = 0) Then
            ' ShowError()
            ' End If
            ' * Workaround StopIRQ may return wrong OK-Values *
            IO1388_StopIRQ(nCard)
            ' * Disable all interrupts *
            If (IO1388_WriteIntRise(nCard, 0) = 0) Then
                ShowError()
            End If
            If (IO1388_WriteIntFall(nCard, 0) = 0) Then
                ShowError()
            End If
            ' * Reset interrupt-enable *
            If (IO1388_WriteTimerStatus(nCard, 0) = 0) Then
                ShowError()
            End If
            ' * Set new card *
            nCard = 3
            ' * Get state of outputs *
            If (IO1388_ReadOutputs(nCard, x) = 0) Then
                ShowError()
            End If
            nOutputs = x
            ' * Get actual state of inputs iof the new card *
            If (IO1388_ReadInputs(nCard, x) = 0) Then
                ShowError()
            Else
                ' * Show the inputs *
                CheckIn0.CheckState = TestBit(x, 0)
                CheckIn1.CheckState = TestBit(x, 1)
                CheckIn2.CheckState = TestBit(x, 2)
                CheckIn3.CheckState = TestBit(x, 3)
                CheckIn4.CheckState = TestBit(x, 4)
                CheckIn5.CheckState = TestBit(x, 5)
                CheckIn6.CheckState = TestBit(x, 6)
                CheckIn7.CheckState = TestBit(x, 7)
                CheckIn8.CheckState = TestBit(x, 8)
                CheckIn9.CheckState = TestBit(x, 9)
                CheckIn10.CheckState = TestBit(x, 10)
                CheckIn11.CheckState = TestBit(x, 11)
                CheckIn12.CheckState = TestBit(x, 12)
                CheckIn13.CheckState = TestBit(x, 13)
                CheckIn14.CheckState = TestBit(x, 14)
                CheckIn15.CheckState = TestBit(x, 15)
                If (bCardtype32) Then
                    CheckIn16.CheckState = TestBit(x, 16)
                    CheckIn17.CheckState = TestBit(x, 17)
                    CheckIn18.CheckState = TestBit(x, 18)
                    CheckIn19.CheckState = TestBit(x, 19)
                    CheckIn20.CheckState = TestBit(x, 20)
                    CheckIn21.CheckState = TestBit(x, 21)
                    CheckIn22.CheckState = TestBit(x, 22)
                    CheckIn23.CheckState = TestBit(x, 23)
                    CheckIn24.CheckState = TestBit(x, 24)
                    CheckIn25.CheckState = TestBit(x, 25)
                    CheckIn26.CheckState = TestBit(x, 26)
                    CheckIn27.CheckState = TestBit(x, 27)
                    CheckIn28.CheckState = TestBit(x, 28)
                    CheckIn29.CheckState = TestBit(x, 29)
                    CheckIn30.CheckState = TestBit(x, 30)
                    CheckIn31.CheckState = TestBit(x, 31)
                End If
            End If
            ' * Enable all interrupts *
            If (IO1388_WriteIntRise(nCard, &HFFFFFFFF) = 0) Then
                ShowError()
            End If
            If (IO1388_WriteIntFall(nCard, &HFFFFFFFF) = 0) Then
                ShowError()
            End If
            ' * Set global- and IO-interrupt-enable *
            If (IO1388_WriteTimerStatus(nCard, IO1388_GLOBAL_IRQ_ENABLE + IO1388_IO_IRQ_ENABLE) = 0) Then
                ShowError()
            End If
            ' * Start irq handling for new card *
            ' If (IO1388_StartIRQ(nCard) = 0) Then
            ' ShowError()
            ' End If
            ' * Workaround StartIRQ may return wrong OK-Values *
            IO1388_StartIRQ(nCard)
            ' * Update visible elements *
            UpdateCardData()
            ' * Update view *
            UpdateView()
        End If
	End Sub
	
	Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
		UpdateView()
	End Sub
End Class